package raptor.ui;

import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;
import java.text.DateFormat;
import java.util.Date;
import java.util.List;
import java.util.Locale;

import raptor.model.*;
import raptor.persistence.*;

public class ConsoleTester
{

	/**
	 * @param args
	 * @throws MalformedFileException 
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException, MalformedFileException
	{
		DateFormat format = DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.MEDIUM, Locale.ITALY);
		System.out.println(format.format(new Date()));
		
		SectionReader sectionReader = new MySectionReader();
		RaptorSystem raptor = new RaptorSystem(sectionReader);
		raptor.loadData();
		
		TransitReader transitReader = new MyTransitReader();
		Reader reader = new FileReader("transits.txt");
		List<Transit> transits = transitReader.readTransits(reader);
		reader.close();
		
		for (Transit transit : transits)
		{
			raptor.putTransit(transit);
		}
		
		for (SpeedingTicket st : raptor.getSpeedingTickets())
		{
			System.out.println(st);
		}
	}

}
