package raptor.ui;

import java.awt.event.*;
import javax.swing.*;

import raptor.model.*;

public class MainFrame extends JFrame implements ActionListener
{
	private static final long serialVersionUID = 1L;

	private Controller controller;

	private JTextArea up;
	private JTextArea mid;
	private JTextArea bottom;

	private JButton avanti;

	public MainFrame(Controller controller)
	{
		this.controller = controller;

		initGui();
		showSections();
		showTransits();
	}

	private void showSections()
	{
		StringBuilder sb = new StringBuilder();
		for (Section section : controller.getSections())
		{
			sb.append(section);
			sb.append("\n");
		}
		up.setText(sb.toString());
	}

	private void showTransits()
	{
		StringBuilder sb = new StringBuilder();
		for (Transit transit : controller.getAvailableTransits())
		{
			sb.append(transit);
			sb.append("\n");
		}
		mid.setText(sb.toString());
	}

	private void showSpeedingTickets()
	{
		StringBuilder sb = new StringBuilder();
		for (SpeedingTicket speedingTicket : controller.getSpeedingTickets())
		{
			sb.append(speedingTicket);
			sb.append("\n");
		}
		bottom.setText(sb.toString());
	}

	private void initGui()
	{
		getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.PAGE_AXIS));
		getContentPane().add(new JLabel("Elenco sezioni controllate"));
		up = new JTextArea(5, 50);
		getContentPane().add(up);
		getContentPane().add(new JLabel("Elenco transiti registrati"));
		mid = new JTextArea(5, 50);
		getContentPane().add(mid);
		avanti = new JButton("Elabora Prossimo Transito");
		getContentPane().add(avanti);
		avanti.addActionListener(this);
		bottom = new JTextArea(5, 50);
		getContentPane().add(bottom);
		pack();
	}

	public void actionPerformed(ActionEvent e)
	{
		if (controller.hasTransits())
		{
			controller.putTransitInSystem();
			if (!controller.hasTransits())
			{
				avanti.setEnabled(false);
			}

			showTransits();
			showSpeedingTickets();
		}
	}
}
