package raptor.ui;

import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;
import java.util.List;

import raptor.model.RaptorSystem;
import raptor.model.Section;
import raptor.model.SpeedingTicket;
import raptor.model.Transit;
import raptor.persistence.MalformedFileException;
import raptor.persistence.MyTransitReader;
import raptor.persistence.TransitReader;

public class MyController implements Controller
{
	private RaptorSystem raptor;
	private List<Transit> transits;
	
	public MyController(RaptorSystem raptor) throws IOException, MalformedFileException
	{
		this.raptor = raptor;
		
		TransitReader transitReader = new MyTransitReader();
		Reader reader = new FileReader("transits.txt");
		this.transits = transitReader.readTransits(reader);
		reader.close();
	}

	@Override
	public Iterable<Section> getSections()
	{
		return raptor.getSections();
	}
	
	@Override
	public Iterable<Transit> getAvailableTransits()
	{
		return transits;
	}

	@Override
	public Iterable<SpeedingTicket> getSpeedingTickets()
	{
		return raptor.getSpeedingTickets();
	}

	@Override
	public void putTransitInSystem()
	{
		if (!transits.isEmpty())
		{
			Transit transit = transits.get(0);
			transits.remove(0);
			raptor.putTransit(transit);
		}
	}

	@Override
	public boolean hasTransits()
	{
		return !transits.isEmpty();
	}
}
